"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Rect = _styledComponents["default"].rect.attrs(function (_ref) {
  var contrastMode = _ref.contrastMode,
      _ref$theme$colors = _ref.theme.colors,
      black = _ref$theme$colors.black,
      purple800 = _ref$theme$colors.purple800;
  return {
    fill: contrastMode ? black : purple800,
    rx: 5
  };
}).withConfig({
  displayName: "_TagCamera__Rect",
  componentId: "hd1e85-0"
})([""]);

var Circle = _styledComponents["default"].circle.attrs(function (_ref2) {
  var contrastMode = _ref2.contrastMode,
      _ref2$theme$colors = _ref2.theme.colors,
      black = _ref2$theme$colors.black,
      purple800 = _ref2$theme$colors.purple800,
      white = _ref2$theme$colors.white;
  return {
    fill: contrastMode ? black : purple800,
    stroke: white
  };
}).withConfig({
  displayName: "_TagCamera__Circle",
  componentId: "hd1e85-1"
})([""]);

var TagCamera = /*#__PURE__*/function (_React$Component) {
  _inherits(TagCamera, _React$Component);

  var _super = _createSuper(TagCamera);

  function TagCamera() {
    _classCallCheck(this, TagCamera);

    return _super.apply(this, arguments);
  }

  _createClass(TagCamera, [{
    key: "render",
    value: function render() {
      return /*#__PURE__*/_react["default"].createElement("g", {
        transform: "translate(16, 6) scale(0.75)"
      }, /*#__PURE__*/_react["default"].createElement(Rect, _extends({}, this.props, {
        x: "0",
        y: "4",
        width: "30",
        height: "24"
      })), /*#__PURE__*/_react["default"].createElement(Rect, _extends({}, this.props, {
        x: "5",
        y: "0",
        width: "20",
        height: "25"
      })), /*#__PURE__*/_react["default"].createElement(Circle, _extends({}, this.props, {
        cx: "15",
        cy: "15",
        r: "6",
        strokeWidth: "4"
      })));
    }
  }]);

  return TagCamera;
}(_react["default"].Component);

exports["default"] = TagCamera;