"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _moment = _interopRequireDefault(require("moment"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _selectors = require("../../theme/selectors");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _createSuper(Derived) { return function () { var Super = _getPrototypeOf(Derived), result; if (_isNativeReflectConstruct()) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var HEIGHT_PX = 29;

var RangeSelectorWrapper = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__RangeSelectorWrapper",
  componentId: "sc-1wrqtw2-0"
})(["border-left:1px solid ", ";min-width:75px;"], function (props) {
  return props.theme.colors.gray200;
});

var SelectedRangeWrapper = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__SelectedRangeWrapper",
  componentId: "sc-1wrqtw2-1"
})(["background-color:transparent;cursor:pointer;padding:", " ", ";display:flex;justify-content:space-between;line-height:21px;"], (0, _selectors.spacing)('xxs'), (0, _selectors.spacing)('xs'));

var SelectedRange = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__SelectedRange",
  componentId: "sc-1wrqtw2-2"
})(["color:", ";"], function (props) {
  return props.theme.colors.purple900;
});

var RangeOptionsListWrapper = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__RangeOptionsListWrapper",
  componentId: "sc-1wrqtw2-3"
})(["z-index:", ";position:fixed;top:0;bottom:0;right:0;left:0;"], function (props) {
  return props.theme.layers.dropdown;
});

var RangeOptionsList = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__RangeOptionsList",
  componentId: "sc-1wrqtw2-4"
})(["background-color:", ";border:1px solid ", ";color:", ";box-sizing:border-box;position:absolute;text-align:left;"], function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.theme.colors.gray200;
}, function (props) {
  return props.theme.colors.purple900;
});

var CaretIconsContainer = _styledComponents["default"].span.withConfig({
  displayName: "_RangeSelector__CaretIconsContainer",
  componentId: "sc-1wrqtw2-5"
})(["display:flex;flex-direction:column;justify-content:center;margin-left:", ";i{font-size:", ";line-height:7px;}"], (0, _selectors.spacing)('xs'), function (props) {
  return props.theme.fontSizes.tiny;
});

var RangeOption = _styledComponents["default"].div.withConfig({
  displayName: "_RangeSelector__RangeOption",
  componentId: "sc-1wrqtw2-6"
})(["line-height:", "px;cursor:pointer;padding:", " ", ";&:hover{background-color:", ";}", ";"], HEIGHT_PX, (0, _selectors.spacing)('none'), (0, _selectors.spacing)('xs'), function (props) {
  return props.theme.colors.gray50;
}, function (props) {
  return props.selected && "\n    color: ".concat(props.theme.colors.blue400, ";\n  ");
});

var rangeOptions = [{
  label: '15min',
  valueMs: _moment["default"].duration(15, 'minutes').asMilliseconds()
}, {
  label: '30min',
  valueMs: _moment["default"].duration(30, 'minutes').asMilliseconds()
}, {
  label: '1h',
  valueMs: _moment["default"].duration(1, 'hour').asMilliseconds()
}, {
  label: '3h',
  valueMs: _moment["default"].duration(3, 'hours').asMilliseconds()
}, {
  label: '6h',
  valueMs: _moment["default"].duration(6, 'hours').asMilliseconds()
}, {
  label: '24h',
  valueMs: _moment["default"].duration(24, 'hours').asMilliseconds()
}, {
  label: '7d',
  valueMs: _moment["default"].duration(7, 'days').asMilliseconds()
}];

var RangeSelector = /*#__PURE__*/function (_React$Component) {
  _inherits(RangeSelector, _React$Component);

  var _super = _createSuper(RangeSelector);

  function RangeSelector(props, context) {
    var _this;

    _classCallCheck(this, RangeSelector);

    _this = _super.call(this, props, context);
    _this.state = {
      isOpen: false
    };
    _this.saveNodeRef = _this.saveNodeRef.bind(_assertThisInitialized(_this));
    _this.handleDropDownClick = _this.handleDropDownClick.bind(_assertThisInitialized(_this));
    _this.handleBackgroundClick = _this.handleBackgroundClick.bind(_assertThisInitialized(_this));
    return _this;
  }

  _createClass(RangeSelector, [{
    key: "handleDropDownClick",
    value: function handleDropDownClick() {
      this.setState({
        isOpen: true
      });
    }
  }, {
    key: "handleBackgroundClick",
    value: function handleBackgroundClick() {
      this.setState({
        isOpen: false
      });
    }
  }, {
    key: "saveNodeRef",
    value: function saveNodeRef(ref) {
      this.containerRef = ref;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var rangeMs = this.props.rangeMs;
      var isOpen = this.state.isOpen;
      var selectedRangeIndex = rangeOptions.findIndex(function (r) {
        return r.valueMs === rangeMs;
      });
      var selectedRangeLabel = rangeOptions.find(function (r) {
        return r.valueMs === rangeMs;
      }).label;
      var anchorEl = this.containerRef && this.containerRef.getBoundingClientRect();
      var menuStyle = anchorEl ? {
        left: anchorEl.right - anchorEl.width,
        minWidth: anchorEl.width + 1,
        top: anchorEl.top - selectedRangeIndex * HEIGHT_PX - 1
      } : {};
      return /*#__PURE__*/_react["default"].createElement(RangeSelectorWrapper, {
        ref: this.saveNodeRef
      }, /*#__PURE__*/_react["default"].createElement(SelectedRangeWrapper, {
        onClick: this.handleDropDownClick
      }, /*#__PURE__*/_react["default"].createElement(SelectedRange, null, selectedRangeLabel), /*#__PURE__*/_react["default"].createElement(CaretIconsContainer, null, /*#__PURE__*/_react["default"].createElement("i", {
        className: "fa fa-caret-up"
      }), /*#__PURE__*/_react["default"].createElement("i", {
        className: "fa fa-caret-down"
      }))), isOpen && /*#__PURE__*/_react["default"].createElement(RangeOptionsListWrapper, {
        onClick: this.handleBackgroundClick
      }, /*#__PURE__*/_react["default"].createElement(RangeOptionsList, {
        style: menuStyle
      }, rangeOptions.map(function (_ref) {
        var valueMs = _ref.valueMs,
            label = _ref.label;
        return /*#__PURE__*/_react["default"].createElement(RangeOption, {
          key: valueMs,
          selected: valueMs === rangeMs,
          onClick: function onClick() {
            return _this2.props.onChange(valueMs);
          }
        }, label);
      }))));
    }
  }]);

  return RangeSelector;
}(_react["default"].Component);

RangeSelector.propTypes = {
  onChange: _propTypes["default"].func.isRequired,
  rangeMs: _propTypes["default"].number.isRequired
};
var _default = RangeSelector;
exports["default"] = _default;